APT-CACHE(8)

NOME
apt-cache - interroga la cache di APT

SINOSSI

apt-cache [-agipns] [-o=stringa_config] [-c=file_config] {gencaches | showpkg pacch... | showsrc pacch... | stats | dump | dumpavail | unmet | search espr_reg... | show pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | depends pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | rdepends pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | pkgnames [prefisso] | dotty pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | xvcg pacch [{=numero_versione_pacch | /rilascio_obiettivo}]... | policy [pacch...] | madison pacch... | {-v | --version} | {-h | --help}}

DESCRIZIONE

apt-cache esegue una varietà di operazioni sulla cache dei pacchetti di APT. apt-cache non manipola lo stato del sistema ma fornisce operazioni per fare ricerche e generare risultati interessanti partendo dai metadati dei pacchetti. I metadati vengono acquisiti e aggiornati attraverso il comando «update» di, ad esempio, apt-get, perciò possono non essere più attuali se l'ultimo aggiornamento è stato fatto troppo tempo prima, ma d'altro canto apt-cache funziona in modo indipendente dalla disponibilità delle fonti configurate (cioè anche fuori linea).

A meno che non venga fornita l'opzione -h o --help, deve essere presente uno dei comandi seguenti.

gencaches
    gencaches crea la cache dei pacchetti di APT. Ciò viene fatto implicitamente da tutti i comandi che hanno bisogno di tale cache, se essa manca o non è aggiornata.

showpkg pacch...
    showpkg mostra informazioni sui pacchetti elencati nella riga di comando. I restanti argomenti sono nomi di pacchetto. Sono elencate le versioni disponibili e le dipendenze inverse di ogni pacchetto, oltre alle dipendenze dirette per ogni versione. Le dipendenze dirette (normali) sono quei pacchetti da cui dipende il pacchetto in questione; le dipendenze inverse sono quei pacchetti che dipendono dal pacchetto in questione. Quindi, per un pacchetto, devono essere soddisfatte le dipendenze dirette, ma non necessariamente quelle inverse. Per esempio, apt-cache showpkg libreadline2 produce un risultato simile al seguente:

        Package: libreadline2
        Versions: 2.1-12(/var/state/apt/lists/pinco_Packages),
        Reverse Depends:
          libreadlineg2,libreadline2
          libreadline2-altdev,libreadline2
        Dependencies:
        2.1-12 - libc5 (2 5.4.0-0) ncurses3.0 (0 (null))
        Provides:
        2.1-12 -
        Reverse Provides:
    Quindi si vede che libreadline2, versione 2.1-12, dipende da libc5 e ncurses3.0 che devono essere installati affinché libreadline2 funzioni. A loro volta, libreadlineg2 e libreadline2-altdev dipendono da libreadline2. Se libreadline2 è installato, devono esserlo anche libc5 e ncurses3.0 (e ldso); non necessariamente devono esserlo libreadlineg2 e libreadline2-altdev. Per il significato specifico del resto dell'output è meglio consultare il codice sorgente di apt.

stats
    stats mostra alcune statistiche sulla cache. Non sono previsti ulteriori argomenti. Le statistiche riportate sono:

        • Totale nomi dei pacchetti è il numero di nomi di pacchetto trovati nella cache.

        • Pacchetti normali è il numero di nomi di pacchetti regolari, normali; sono pacchetti che hanno una corrispondenza uno-a-uno fra il loro nome e il nome usato da altri pacchetti per indicarli nelle loro dipendenze. La maggioranza dei pacchetti ricade in questa categoria.

        • Pacchetti virtuali puri è il numero di pacchetti che esistono solo come nome di pacchetto virtuale; vale a dire, i pacchetti «forniscono» solamente il nome del pacchetto virtuale e nessun pacchetto in realtà usa quel nome. Per esempio, «mail-transport-agent» nel sistema Debian è un pacchetto virtuale puro; diversi pacchetti forniscono «mail-transport-agent», ma non c'è alcun pacchetto chiamato «mail-transport-agent».

        • Pacchetti virtuali singoli è il numero di pacchetti virtuali per cui esiste solo un pacchetto che li fornisce. Per esempio, nel sistema Debian «X11-text-viewer» è un pacchetto virtuale, ma solo un pacchetto, xless, fornisce «X11-text-viewer».

        • Pacchetti virtuali misti è il numero di pacchetti che forniscono un particolare pacchetto virtuale oppure hanno il nome uguale a quello del pacchetto virtuale. Per esempio, nel sistema Debian «debconf» è sia un pacchetto vero e proprio, sia è fornito dal pacchetto debconf-tiny.

        • Mancanti è il numero di nomi di pacchetto che vengono menzionati in una dipendenza ma non sono forniti da alcun pacchetto. I pacchetti mancanti possono essere un segno che non si ha accesso a una distribuzione completa o che un pacchetto (reale o virtuale) è stato eliminato da una distribuzione. Di solito vengono menzionati da clausole Conflicts o Breaks.

        • Totale versioni distinte è il numero di versioni di pacchetti trovate nella cache. Se si ha accesso a più di una distribuzione (ad esempio sia «stable» che «unstable»), questo valore può essere decisamente più grande del numero dei nomi totali di pacchetto.

        • Totale dipendenze è il numero di relazioni di dipendenza dichiarate da tutti i pacchetti nella cache.

showsrc pacch...
    showsrc mostra tutti i pacchetti sorgente che corrispondono ai nomi dei pacchetti specificati. Vengono mostrate tutte le versioni, così come tutti i record che dichiarano che il nome è quello di un pacchetto binario. Usare --only-source per visualizzare solo i nomi di pacchetti sorgente.

dump
    dump mostra un breve elenco di tutti i pacchetti nella cache. Serve soprattutto a scopo di debug.

dumpavail
    dumpavail stampa una lista di pacchetti disponibili su stdout. Questa è adatta all'uso con dpkg(1) ed è usata dal metodo dselect(1).

unmet
    unmet mostra un riassunto di tutte le dipendenze non soddisfatte nella cache dei pacchetti.

show pacch...
    show esegue una funzione simile a dpkg --print-avail; mostra i record dei pacchetti per i pacchetti specificati.

search espr_reg...
    search esegue una ricerca completa a tutto testo in tutti gli elenchi di pacchetti disponibili cercando il modello di espressione regolare POSIX specificato; vedere regex(7). Cerca le occorrenze dell'espressione regolare nei nomi e nelle descrizioni dei pacchetti e stampa il nome e la descrizione breve dei pacchetti, inclusi quelli virtuali. Se viene fornita l'opzione --full, per ciascun pacchetto che soddisfa la ricerca viene prodotto un output identico a quello di show; se viene fornita l'opzione --names-only la ricerca viene fatta solo sul nome del pacchetto e dei pacchetti forniti e non sulla descrizione lunga.

    È possibile usare argomenti separati per specificare più modelli di ricerca che vengono combinati con un AND.

depends pacch...
    depends mostra un elenco con ogni dipendenza di un pacchetto e tutti i possibili altri pacchetti che possono soddisfare quella dipendenza.

rdepends pacch...
    rdepends mostra un elenco di tutte le dipendenze inverse di un pacchetto.

pkgnames [prefisso]
    Questo comando stampa il nome di tutti i pacchetti che APT conosce. L'argomento opzionale è un prefisso per filtrare l'elenco dei nomi. Il risultato è adatto ad essere usato in una funzione di shell di completamento automatico tramite Tab e viene generato molto rapidamente. Questo comando viene usato al meglio con l'opzione --generate.

    Notare che un pacchetto che APT conosce non è necessariamente disponibile per essere scaricato, installabile o installato; ad esempio, i pacchetti virtuali sono anch'essi compresi nell'elenco generato.

dotty pacch...
    dotty accetta un elenco di pacchetti dalla riga di comando e genera un output adatto all'uso da parte di dotty del pacchetto GraphViz[1]. Il risultato sarà un insieme di nodi e linee che rappresentano le relazioni fra i pacchetti. In modo predefinito dai pacchetti dati si risalirà a tutti i pacchetti delle dipendenze; ciò può produrre un grafo molto grande. Per limitare il risultato ai soli pacchetti elencati sulla riga di comando, impostare l'opzione APT::Cache::GivenOnly.

    I nodi risultanti avranno diverse forme: i pacchetti normali sono rettangoli, i pacchetti virtuali puri sono triangoli, i pacchetti virtuali misti sono rombi, i pacchetti mancanti sono esagoni. I rettangoli arancioni indicano che la ricorsione è stata arrestata (pacchetti foglia), le linee blu sono pre-dipendenze, le linee verdi sono conflitti.

    Attenzione: dotty non può creare i grafi degli insiemi più grandi di pacchetti.

xvcg pacch...
    Stessa cosa di dotty, ma per xvcg dello strumento VCG[2].

policy [pacch...]
    policy è pensato per aiutare a fare il debug di problemi relativi al file delle preferenze. Senza argomenti stampa le priorità di ciascuna fonte. Altrimenti stampa informazioni dettagliate sulla selezione di priorità del pacchetto indicato.

madison pacch...
    Il comando madison di apt-cache cerca di imitare il formato di uscita e un sottoinsieme delle funzionalità di madison, lo strumento di gestione dell'archivio di Debian. Mostra le versioni disponibili di un pacchetto in forma tabellare. Contrariamente al madison originale, può mostrare informazioni solamente per l'architettura per cui APT ha recuperato gli elenchi dei pacchetti (APT::Architecture).

OPZIONI

Tutte le opzioni a riga di comando si possono impostare usando il file di configurazione; le descrizioni indicano l'opzione da impostare. Per le opzioni booleane si può scavalcare il file di configurazione usando qualcosa come -f-, --no-f, -f=no o diverse altre varianti.

-p, --pkg-cache
    Seleziona il file in cui memorizzare la cache dei pacchetti. Questa è la cache primaria usata da tutte le operazioni. Voce di configurazione: Dir::Cache::pkgcache.

-s, --src-cache
    Seleziona il file in cui memorizzare la cache dei sorgenti. Questa è usata solo da gencaches e memorizza una versione analizzata delle informazioni sui pacchetti provenienti da fonti remote. Al momento della costruzione della cache dei pacchetti, la cache dei sorgenti viene usata per evitare di rileggere tutti i file dei pacchetti. Voce di configurazione: Dir::Cache::srcpkgcache.

-q, --quiet
    Silenzioso; produce un output adatto per un file di registro, omettendo gli indicatori di avanzamento. Ulteriori q produrranno un risultato ancor più silenzioso, fino a un massimo di 2. È anche possibile usare -q=n per impostare il livello di silenziosità a n, scavalcando il file di configurazione. Voce di configurazione: quiet.

-i, --important
    Stampa solo le dipendenze importanti; da usarsi con unmet e depends. Fa sì che vengano stampate solo le relazioni Depends e Pre-Depends. Voce di configurazione: APT::Cache::Important.

--no-pre-depends, --no-depends, --no-recommends, --no-suggests, --no-conflicts, --no-breaks, --no-replaces, --no-enhances
    In modo predefinito depends e rdepends stampano tutte le dipendenze. Ciò può essere modificato con queste opzioni che omettono il tipo specificato di dipendenza. Voce di configurazione APT::Cache::ShowTipoDipendenza, ad es. APT::Cache::ShowRecommends.

--implicit
    In modo predefinito depends e rdepends stampano solo le dipendenze esplicitamente espresse nei metadati. Con questa opzione mostrano anche le dipendenze aggiunte implicitamente sulla base dei dati incontrati. Ad esempio un Conflicts: pippo esprime implicitamente che questo pacchetto va in conflitto anche con il pacchetto pippo da qualsiasi altra architettura. Voce di configurazione: APT::Cache::ShowImplicit.

-f, --full
    Stampa l'intero record dei pacchetti durante la ricerca. Voce di configurazione: APT::Cache::ShowFull.

-a, --all-versions
    Stampa i record completi per tutte le versioni disponibili. Questa è l'impostazione predefinita; per disattivarla, usare --no-all-versions. Se si specifica --no-all-versions, verrà visualizzata solo la versione candidata (quella che sarebbe scelta per l'installazione). Questa opzione è applicabile solo al comando show. Voce di configurazione: APT::Cache::AllVersions.

-g, --generate
    Esegui la rigenerazione automatica della cache dei pachetti, piuttosto che usare la cache così com'è. Questa è l'impostazione predefinita; per disattivarla, usare --no-generate. Voce di configurazione: APT::Cache::Generate.

--names-only, -n
    Cerca soltanto nei nomi dei pacchetti e dei pacchetti forniti, non nelle descrizioni lunghe. Voce di configurazione: APT::Cache::NamesOnly.

--all-names
    Fai sì che pkgnames stampi tutti i nomi, inclusi i pacchetti virtuali e le dipendenze mancanti. Voce di configurazione: APT::Cache::AllNames.

--recurse
    Rendi ricorsivi depends e rdepends in modo che tutti i pacchetti menzionati siano stampati una sola volta. Voce di configurazione: APT::Cache::RecurseDepends.

--installed
    Limita l'output di depends e rdepends ai pacchetti attualmente installati. Voce di configurazione: APT::Cache::Installed.

--with-source nomefile
    Aggiunge il file fornito come fonte di metadati. Può essere ripetuto per aggiungere più file. Attualmente sono gestiti file *.deb, *.dsc, *.changes, Sources e Packages, oltre a directory di pacchetti sorgente. La corrispondenza con i file si basa solo sul nome, non sul loro contenuto!

    Sources e Packages possono essere compressi in qualsiasi formato gestito da apt, a patto che abbiano l'estensione corretta. Se è necessario archiviare più file in una directory si può aggiungere a un nome a propria scelta un prefisso che termina con un trattino basso («_»). Esempio: mio.esempio_Packages.xz

    Notare che queste fonti vengono trattate come fidate (vedere apt-secure(8)). Voce di configurazione: APT::Sources::With.

-h, --help
    Mostra un breve riassunto sull'uso.

-v, --version
    Mostra la versione del programma.

--audit
    Show audit (and notice) messages. This overrides the quiet option, but only for notice messages, not progress ones.

-c, --config-file
    File di configurazione; specifica un file di configurazione da usare. Il programma legge il file di configurazione predefinito e poi questo file di configurazione. Se è necessario modificare le impostazioni di configurazione prima che vengano analizzati i file di configurazione predefiniti, specificare un file con la variabile d'ambiente APT_CONFIG. Vedere apt.conf(5) per informazioni sulla sintassi.

-o, --option
    Set a Configuration Option; This will set an arbitrary configuration option. The syntax is -o Foo::Bar=bar. -o and --option can be used multiple times to set different options.

--no-color, --color
    Turn colors on or off. Colors are on by default on supported terminals for apt(8) and can also be disabled using the NO_COLOR or APT_NO_COLOR environment variables, or further configured by the APT::Color configuration option and scope, see apt.conf(5) for information on that.

FILE

/etc/apt/sources.list
    Posizioni da cui scaricare i pacchetti. Voce di configurazione: Dir::Etc::SourceList.

/etc/apt/sources.list.d/
    Frammenti di file per le posizioni da cui scaricare i pacchetti. Voce di configurazione: Dir::Etc::SourceParts.

/var/lib/apt/lists/
    Area di archiviazione per le informazioni sullo stato di ciascuna risorsa dei pacchetti specificata in sources.list(5) Voce di configurazione: Dir::State::Lists.

/var/lib/apt/lists/partial/
    Area di archiviazione per le informazioni di stato in transito. Voce di configurazione: Dir::State::Lists (partial verrà implicitamente aggiunto in fondo al nome)

VEDERE ANCHE

apt.conf(5), sources.list(5), apt-get(8), apt-patterns(7)

DIAGNOSTICA

apt-cache restituisce zero in caso di funzionamento normale e il valore decimale 100 in caso di errore.

BUG

Pagina dei bug di APT[3]. Se si desidera segnalare un bug in APT, vedere /usr/share/doc/debian/bug-reporting.txt o il comando reportbug(1).

TRADUZIONE

Traduzione in italiano a cura del Team italiano di localizzazione di Debian <debian-l10n-italian@lists.debian.org>. In particolare hanno contribuito Eugenia Franzoni (2000), Hugh Hartmann (2000-2012), Gabriele Stilli (2012), Beatrice Torracca (2012, 2014, 2015).

Notare che questa versione tradotta del documento può contenere parti non tradotte. Ciò è voluto, per evitare di perdere contenuti quando la traduzione non è aggiornata rispetto all'originale.

AUTORI

Jason Gunthorpe

Team APT

NOTE

1.  GraphViz
    https://graphviz.org/

2.  strumento VCG
    https://www.rw.cdl.uni-saarland.de/people/sander/private/html/gsvcg1.html

3.  Pagina dei bug di APT
    https://bugs.debian.org/src:apt